package de.joethei.hs.java2.vorlesungen.binaryTree;

import java.util.logging.Logger;

public class Node<T> {

    private T value;
    private Node<T> left;
    private Node<T> right;

    private Logger logger = Logger.getLogger(getClass().getName());

    public Node() {
    }

    public Node(T value) {
        this.value = value;
    }

    public Node(T value, Node<T> left, Node<T> right) {
        this.value = value;
        this.left = left;
        this.right = right;
    }

    public T getValue() {
        return value;
    }

    public Node<T> getLeft() {
        return left;
    }

    public Node<T> getRight() {
        return right;
    }

    @Override
    public String toString() {
        return super.toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Node) {
            Node node = (Node) obj;
            if(node.value.equals(this.value) && node.left == null && node.right == null) return true;
            return node.value.equals(this.value) && node.left.equals(this.left) && node.right.equals(this.right);
        }
        return false;
    }
}